#include "stm32f10x.h"
#include <stdio.h>
#include <math.h>

USART_InitTypeDef USART_InitStructure;


 void usart_setup(void){
//  RCC->APB2ENR |= RCC_APB2ENR_IOPAEN;              // enable clock for GPIOA
//  GPIOA->CRH   |= (0x0BUL  << 4);                  // Tx (PA9) alt. out push-pull
//  GPIOA->CRH   |= (0x04UL  << 8);                  // Rx (PA10) in floating
  RCC->APB2ENR |= RCC_APB2ENR_USART1EN;            // enable clock for USART1
  USART1->BRR  = (500000L/38400L)<<4;                // set baudrate
  USART1->CR1 |= (USART_CR1_RE | USART_CR1_TE);  // RX, TX enable
  USART1->CR1 |= USART_CR1_UE;                    // USART enable
 }
  
 int putchar(int ch){
  while (!(USART1->SR & USART_SR_TXE));
  USART1->DR = (ch & 0xFF);
  return (ch);
 }
  
 int getchar(void)  {
  while (!(USART1->SR & USART_SR_RXNE));
  return ((int)(USART1->DR & 0xFF));
 }

 void main(){ 
  
   u32 k;
   double i;
   
   
   RCC->APB2ENR |= RCC_APB2ENR_IOPAEN;   
   RCC->APB2ENR |= RCC_APB2ENR_IOPCEN;   
   RCC->APB2ENR |= RCC_APB2ENR_ADC1EN;   
   RCC->APB2ENR |= RCC_APB2ENR_USART1EN;
   
   GPIOA->CRL &= ~(GPIO_CRL_MODE0_0 | GPIO_CRL_MODE0_1);
   GPIOA->CRL &= ~GPIO_CRL_CNF0_0;  
   GPIOA->CRL |= GPIO_CRL_CNF0_1;     
   GPIOA->ODR &= ~GPIO_ODR_ODR0;  

   GPIOA->CRH |= GPIO_CRH_MODE9_0 | GPIO_CRH_MODE9_1;
   GPIOA->CRH &= ~GPIO_CRH_CNF9_0; 
   GPIOA->CRH |= GPIO_CRH_CNF9_1; 
   

   GPIOC->CRH |= GPIO_CRH_MODE8_0 | GPIO_CRH_MODE8_1;
   GPIOC->CRH &= ~GPIO_CRH_CNF8;    
   
   GPIOC->CRH |= GPIO_CRH_MODE9_0 | GPIO_CRH_MODE9_1;
   GPIOC->CRH &= ~GPIO_CRH_CNF9;    
 
   /* USARTy configuration ------------------------------------------------------*/
  /* USARTy configured as follow:
        - BaudRate = 115200 baud  
        - Word Length = 8 Bits
        - One Stop Bit
        - No parity
        - Hardware flow control disabled (RTS and CTS signals)
        - Receive and transmit enabled
  */
  USART_InitStructure.USART_BaudRate = 38400;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No ;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

  /* Configure the USARTy */
  USART_Init(USART1, &USART_InitStructure);   
   
   usart_setup();

   putchar(27);
   printf("\r------------------------------------------------------\r"); 
   
  // for (i=0; i<100000; i++);
   
    printf("Hello world!"); 
   
   
   while(1){
     
    //putchar('A');
    // but = GPIOA->IDR & GPIO_IDR_IDR0;
     
     
     for (i=0; i<3.14*2; i=i+0.04){
      putchar(128+(signed int)96*sin(i));
      for (k=0; k<100000; k++);  
     }
     
     
     if(!(GPIOA->IDR & GPIO_IDR_IDR0)){ 
      GPIOC->ODR |= GPIO_ODR_ODR8;  
      GPIOC->ODR &= ~GPIO_ODR_ODR9;
     }
     else{
      GPIOC->ODR &= ~GPIO_ODR_ODR8;
      GPIOC->ODR |= GPIO_ODR_ODR9;  
     }
      
   }
 }
